;; -*- DSSSL -*-
;; DSSSLn̓{głxvO
;; functions.dsl
;;


; ́^Ȃǂ̃ioO쐬֐Q
;
(define (char-repeat sym num)
  (string-append (char-repeat sym (- num 1)) sym))

(define (num->alpha num)
  (substring " abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ"
             num (+ num 1)))

(define (num->alphaCAP num)
  (substring " ABCDEFGHIJKLMNOPQRSTUVWXYZ"
             num (+ num 1)))

(define (num->kanji num) ;; i2܂Ŏgp\j
  (if (> num 10)
      (string-append (if (= (quotient num 10) 1)
                         ""
                         (num->kanji (quotient num 10)))
                     "\"
                     (num->kanji (remainder num 10)))
      (case num
        ((0) "") ((1) "") ((2) "") ((3) "O") ((4) "l") ((5) "")
        ((6) "Z") ((7) "") ((8) "") ((9) "") ((10) "\"))))

; [}̃ioO֐
(define (num->roma num)
  (format-number num "i"))

; ioO֐
(define (make-num n exp)
  (case exp
    (('abc) (num->alpha n))
    (('ABC) (num->alphaCAP n))
    (('kanji) (num->kanji n))
    (('roma) (num->roma n))
;    (('hira) (num->hira n))
;    (('kata) (num->hira n))
;    (('iroha-hira) (num->hira n))
;    (('iroha-kata) (num->hira n))
    (('asterisk)  (char-repeat "*" n))

; dag, ddag, P, S, Vert, TeXɏB
    (('dag) (char-repeat "" n))
    (('ddag) (char-repeat "" n))
    (('P) (char-repeat "" n))
    (('S) (char-repeat "" n))
    (('Vert) (char-repeat "a" n))

    (('sharp)  (char-repeat "#" n))
    (else (number->string n))
))


(define (make-numbering nl desc)
(if (equal? #f desc)
  (make-numbering nl *title-number-desc*)
  (letrec ((num-member
            (lambda (e l)
              (cond ((not(list? l)) #f)
                    ((member e l) #t)
                    ((eq? 'nl (car (reverse l)))
                     (let* ((ll (reverse (cdr (reverse l)))))
                       (if (> (length ll) 0)
                           (> e (apply max ll))
                           #t)))
                    (else #f))))
           (match-level
            (lambda (level desc)
              (cond ((null? desc) #f)
                    ((not (list? (car desc))) desc)
                    ((not (list? (caar desc))) (car desc)) ; non-list
                    ((num-member level (caar desc)) (car desc))
                    (else (match-level level (cdr desc)))
                    )))
           (make-infix
            (lambda (nl num infix)
                (cond ((or (eqv? 'last infix) (eqv? "" infix))
                     (make-num (car (reverse nl)) num))
                    ((null? (cdr nl))
                     (make-num (car nl) num))
                    (else
                     (string-append
                      (make-num (car nl) num)
                      infix
                      (make-infix (cdr nl) num infix)))))))

    (cond ((number? nl) (make-numbering (list nl) desc))
          ((not (list? nl)) "")
          ((not (list? desc)) "")
          ((match-level (length nl) desc)
            (let ((d (match-level (length nl) desc)))
                (string-append
                 (caddr d) ;; pre
                 (make-infix nl (cadr d)(cadddr d))
                 (cadddr (cdr d)) ;; post
                 )))
          (else "")))))


;;  i
;;    ĩX^Cwݒ肷

(define *paragraph-style* ;; i̊{ݒ
  (style
   font-size: *base-font-size*
   font-weight: *base-font-weight*
   font-posture: *base-font-posture*
   font-family-name: *base-font-family*
   line-spacing: (cadddr *page-spec*)
   quadding: 'start ;; 
   ))

(define *fli-paragraph-style* ;; ̂i
  (style
   use: *paragraph-style*
   first-line-start-indent: (* *base-font-size* *jisage-factor*)
   ))


(define *indent-step*
  (* *base-font-size* *indent-factor*))


;;  ^mu
;;     - PAGE-HEADER, PAGE-FOOTERQƁBł, styleB

(define *header-footer-style*
  (style
   use: *paragraph-style*
   font-size: (* *base-font-size* 1.0)
   line-spacing: (* (cadddr *page-spec*) 1.0)
   ;;font-posture: 'italic
   ))


;; r
;;
(define *footnote-style*
  (style
   use: *paragraph-style*
   font-size: (* *base-font-size* 1.0)
   line-spacing: (* (cadddr *page-spec*) 1.0)
   ))


;;  
(define (jidori n)
  (make line-field
        field-width: (* *base-font-size* n) ;; n
        (make paragraph
              quadding: 'justify
              last-line-quadding: 'justify
              (process-children))))


;;  o
;;; oparagraph`, Tɂ͒`łȂ̂
;;;@nodẽJEg̊֐pӂĂB

(define (GET-MIDASHI-NUMS node-list)
	(make-numbering (element-number-list node-list) #f))


;;  r

; r̐K\
; ȉnőgŉ\ɂȂƂ̂߂Ɂj
;(define (RUBI) 
;(make glyph-annotation
;        annotation-glyph-placement: 'centered
;        annatation: (process-matching-children 'yomi)
;        (process-children)))
;
;(define (YOMI . f)
;  (let ((factor (if (null? f) *rubi-font-size-factor* (car f))))
;    (make paragraph
;          font-size: (* (inherited-font-size) factor)
;          (process-children))))

; ȓ֋@\
; i݂DSSSLnőgŉ\ɂ́j
(define (YOMI)
  (sosofo-append
    (literal "(")
    (process-children)
    (literal ")")))


;;  Y
(define (SUBSCRIPT   f)
  (let ((factor (if (null? f) *subscript-font-size-factor* (car f))))
    (make math-sequence
          math-display-mode: 'inline
          (make subscript
                font-size: (* (inherited-font-size) factor)
                (process-children)))))

(define (SUPERSCRIPT   f)
  (let ((factor (if (null? f) *superscript-font-size-factor* (car f))))
    (make math-sequence
          math-display-mode: 'inline
          (make superscript
                font-size: (* (inherited-font-size) factor)
                (process-children)))))


;;  
(define (UNDERLINE)
  (make score
        type: 'after
        (process-children)))


;;  
; ̐K\
; ȉnőgŉ\ɂȂƂ̂߂Ɂj
;  _multi-line-inline-noten݂͑Ȃ
;(define (WARICHUU)
;  (make multi-line-inline-note ;; see ISO/IEC10179:1996 12.6.24
;        (process-children)))


;;  _
; _̐K\
; ȉnőgŉ\ɂȂƂ̂߂Ɂj
;  _emphasizing-markn݂͑Ȃ
;(define (KENTEN)
;  (make emphasizing-mark ;; see ISO/IEC10179:1996 12.6.25
;        mark: (literal "E")
;        (process-children)))


;;  
(define (BOLD-SEQ)
  (make sequence
    font-weight: 'bold
    (process-children)))

(define (ITALIC-SEQ)
  (make sequence
    font-posture: 'italic
    (process-children)))

(define (BOLD-ITALIC-SEQ)
  (make sequence
        font-weight: 'bold
        font-posture: 'italic
        (process-children)))

(define (STRIKE-SEQ)
  (make score
    type: 'through
    (process-children)))



;;  ӏ
(define (MAKE-ENUM-EXP nul)
  (make-numbering nul *enum-number-desc*))


 (define (LIST-CONTAINER)
  (make display-group
        ;space-before:
        ;space-after:
        start-indent: (+ (inherited-start-indent)
        (* *indent-factor* *base-font-size*))
))

(define (LIST-ELEMENT lhead)  ;; lhead -- list head string
  (make paragraph
        use: *paragraph-style*
        ;space-before:
        start-indent: (inherited-start-indent)
        first-line-start-indent:
              (- (* *indent-factor* *base-font-size*))
        (make line-field
              field-width: (* *indent-factor* *base-font-size*)
              (literal lhead))
        (process-children-trim)))



;;  ^Cg
(define (TITLE-LARGE)
  (make paragraph
        use: *paragraph-style*
        font-size: (list-ref (list-ref *font-table* 1) 1)
        font-weight: 'bold
        space-before: 
        (car
         (case (gi (first (children (current-node))))
           (("h2" "h3") (title-vertical-spacing "h1" 2))
           (else (title-vertical-spacing "h1" 0))))
        space-after:
        (cadr
         (case (gi (first (children (current-node))))
           (("h2" "h3") (title-vertical-spacing "h1" 2))
           (else (title-vertical-spacing "h1" 0))))
        escapement-space-after:
            ;;ʂcharacter flow object classŎgp
        (title-char-spacing (count (children (current-node)))
            *paper-name*)
        (literal (GET-MIDASHI-NUMS '("H1")))
	(literal "  ")
        (process-children)))


 (define (TITLE-MEDIUM)
  (make paragraph
        use: *paragraph-style*
        font-size: (list-ref (list-ref *font-table* 2) 1)
        font-weight: 'bold
        space-before:
        (let ((b1 (absolute-first-sibling? (current-node)))
              (b2 (string=? (gi (first (children (current-node))))
              "h3")))
          (car
           (cond
            ((and b1 b2) (title-vertical-spacing "h2" 3))
            ((and (not b1) b2) (title-vertical-spacing "h2" 2))
            ((and b1 (not b2)) (title-vertical-spacing "h2" 1))
            (else (title-vertical-spacing "h2" 0)))))
        space-after:
        (let ((b1 (absolute-first-sibling? (current-node)))
              (b2 (string=? (gi (first (children (current-node))))
              "h3")))
          (cadr
           (cond
            ((and b1 b2) (title-vertical-spacing "h2" 3))
            ((and (not b1) b2) (title-vertical-spacing "h2" 2))
            ((and b1 (not b2)) (title-vertical-spacing "h2" 1))
            (else (title-vertical-spacing "h2" 0)))))
        escapement-space-after:
        (title-char-spacing (count (children (current-node)))
              *paper-name*)
        (literal (GET-MIDASHI-NUMS '("H1" "H2")))
        (literal "  ")
        (process-children)))


 (define (TITLE-SMALL)
  (make paragraph
        use: *paragraph-style*
        font-size: (list-ref (list-ref *font-table* 3) 1)
        font-weight: 'bold
        space-before:
        (car
         (if (absolute-first-sibling? (current-node))
             (title-vertical-spacing "h2" 1)
             (title-vertical-spacing "h2" 0)))
        space-after:
        (cadr
         (if (absolute-first-sibling? (current-node))
             (title-vertical-spacing "h2" 1)
             (title-vertical-spacing "h2" 0)))
        escapement-space-after:
        (title-char-spacing (count (children (current-node)))
             *paper-name*)
        (literal (GET-MIDASHI-NUMS '("H1" "H2" "H3")))
        (literal "  ")
        (process-children)))


; car/cdr֐Cm[h֐C

(define (caar a)
	(car (car a)))

(define (cadr a)
	(car (cdr a)))

(define (caddr a)
	(car (cdr (cdr a))))

(define (cadddr a)
	(car (cdr (cdr (cdr a)))))


(define (first a)
	(node-list-first a))

(define (eq? a b)
    	(if (and (not (list? a)) (not (list? b)))
		(equal? a b)
		#f))

(define (eqv? a b)
	(eq? a b))


;----- ֐icountj̒`

(define (count nl)
	 (node-list-count nl))

(define (node-list-count nl)
  (node-list-length (node-list-remove-duplicates nl)))

(define (node-list-remove-duplicates nl)
  (node-list-reduce nl
                    (lambda (result snl)
                      (if (node-list-contains? result snl)
                          result
                          (node-list result snl)))
                    (empty-node-list)))

(define (node-list-contains? nl snl)
  (node-list-reduce nl
                    (lambda (result i)
                      (or result
                          (node-list=? snl i)))
                    #f))

(define (string=? a b)
	(if (and (string? a) (string? b))		(equal? a b)
	#f))
